// Google Sky Test version 0.1  by E.Kako (www.kako.com)

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <winsock.h>
#include <atlbase.h> // ATL֌W
#include <atlcom.h>  // ATL֌W
#include <atlhost.h> // ATL֌W
CComModule _Module;  // ATL֌W

char CurrentPath[512];
float lat,lng;
int zoom;
float delta=5;

void Make_Txt(void)
{
	FILE *fp;
	fp=fopen("param.txt","w");
	if (fp==NULL) { return; }
	fprintf(fp,"LAT,LNG,ZOOM\n");
	fprintf(fp,"%g,%g,%d\n",lat,lng,zoom);
	fclose(fp);
}

int Can_I_reach_Server(char *server_name)
{
	int soc,ret,res;
	WORD version;
	WSADATA wsaData;
	struct hostent *host;

	version = MAKEWORD(1,1);
	ret = WSAStartup(version, &wsaData);
	if (ret != 0) { return -1; } // winsock init error
	soc = socket(PF_INET,SOCK_STREAM,0);
	if (soc == INVALID_SOCKET) { return -1; } // socket init errror
	
	res=0;
	host = gethostbyname(server_name);
	if (host != NULL) { res = 1; } // found
	
	closesocket(soc); 
	WSACleanup();
	return res;
}

LRESULT CALLBACK WndProc (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static CComQIPtr<IWebBrowser2> Browser;
	static HWND hwndIE;
	
	switch (msg)
	{
		case WM_CREATE :
		{
			// ActiveXIER|[lgWindowsJ
			AtlAxWinInit();
			{
				hwndIE = CreateWindow("AtlAxWin71", "Shell.Explorer.2", WS_CHILD|WS_VISIBLE,
						 0, 0, 640, 480,  hwnd, (HMENU)0, GetModuleHandle(NULL), NULL);// for VC2003
			}
			if (hwndIE==NULL) {
				hwndIE = CreateWindow("AtlAxWin80", "Shell.Explorer.2", WS_CHILD|WS_VISIBLE,
						 0, 0, 640, 480,  hwnd, (HMENU)0, GetModuleHandle(NULL), NULL);// for VC2005
			}
			if (hwndIE==NULL) {
				hwndIE = CreateWindow("AtlAxWin90", "Shell.Explorer.2", WS_CHILD|WS_VISIBLE,
						 0, 0, 640, 480,  hwnd, (HMENU)0, GetModuleHandle(NULL), NULL);// for VC2008
			}
			if (hwndIE==NULL) {
				MessageBox( hwnd, "AtlAxWins", "Error", MB_OK) ; EndDialog( hwnd, 0);
				return 0;
			}
			
			CComPtr<IUnknown> punkIE;
			if (AtlAxGetControl(hwndIE, &punkIE) == S_OK) {
				Browser = punkIE;
				if( Browser!=NULL ) {
					CComVariant vempty, vUrl; char buf[512];
					strcpy(buf,CurrentPath); strcat(buf,"\\test.htm");
					vUrl= buf;
					Browser->Navigate2 ( &vUrl, &vempty, &vempty, &vempty, &vempty );
				} else {
					MessageBox( hwnd, "IER|[lbgG[", "Error", MB_OK) ;
					EndDialog(hwnd,0);
				}
			}
			return 0;
		}
		case WM_DESTROY :
			Browser.Release(); PostQuitMessage(0); return 0;
	}
	return DefWindowProc (hwnd, msg, wParam, lParam) ;
}

BOOL My_PreTranslateMessage(HWND hWnd, MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN){
		switch(pMsg->wParam){
			case VK_DOWN:    lat-=delta; Make_Txt(); return TRUE;
			case VK_UP:      lat+=delta; Make_Txt(); return TRUE;
			case VK_LEFT:    lng-=delta; Make_Txt(); return TRUE;
			case VK_RIGHT:   lng+=delta; Make_Txt(); return TRUE;
			case VK_NUMPAD2: lat-=delta; Make_Txt(); return TRUE;
			case VK_NUMPAD8: lat+=delta; Make_Txt(); return TRUE;
			case VK_NUMPAD4: lng-=delta; Make_Txt(); return TRUE;
			case VK_NUMPAD6: lng+=delta; Make_Txt(); return TRUE;
			case VK_SPACE:   zoom++;     Make_Txt(); return TRUE;
		}
	}
	return FALSE;
}

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	static char szAppName[] = "google_browse_test" ;
	HWND	hwnd ;
	MSG		msg ;
	
	if ( Can_I_reach_Server("google.com") != 1 ) {
		MessageBox( 0, "Google.comɐڑł܂", "Error", MB_OK) ; exit(1);
	}
	
	lat=0; lng=0; zoom=2; // l
	
	GetCurrentDirectory(sizeof(CurrentPath),CurrentPath);
	Make_Txt();

	// EChENX̓o^
	WNDCLASSEX wndclass;
	wndclass.cbSize = sizeof (wndclass);
	wndclass.style = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc = WndProc;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance  = hInstance;
	wndclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = szAppName;
	wndclass.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	RegisterClassEx(&wndclass);

	// CEChE̍쐬
	hwnd = CreateWindow (szAppName,"", WS_OVERLAPPEDWINDOW,0,0, 640-20, 480+10, NULL, NULL, hInstance, NULL) ;
	ShowWindow (hwnd, iCmdShow); UpdateWindow (hwnd);

	while (GetMessage (&msg, NULL, 0, 0)) {
		if(!My_PreTranslateMessage(hwnd, &msg)){
			TranslateMessage (&msg) ; DispatchMessage (&msg) ;
		}
	}
	return msg.wParam ;
}
